@use "sass:color";

$card-min-width: 150px;
$card-min-height: 80px;
$pick-color: green;
$ban-color: red;

.card {
  min-height: var(--card-height, $card-min-height);
  min-width: var(--card-width, $card-min-width);
  max-width: 100%;
  width: 1px;
  height: 1px;
  position: relative;
  padding: 0;
  margin: 0;
  user-select: none;
  --card-border-radius: var(--border-radius);
  border-radius: var(--card-border-radius, var(--border-radius));
  border: 1px solid var(--border-color, var(--muted-border-color));
  box-shadow: var(--box-shadow);
  transition: 100ms border, var(--transition) box-shadow;

  &::before {
    content: "";
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    background: linear-gradient(60deg, var(--background-color) 0%, rgba(0, 0, 0, 0) 100%);
    opacity: 0.66;
    z-index: 1;
    pointer-events: none;
    border-radius: var(--card-border-radius);
  }

  &[data-has-pick="false"] {
    .img {
      opacity: 0;
    }
    &::before {
      background: black;
    }
  }

  &[data-has-pick="true"] {
    .img {
      opacity: 1;
    }
  }

  &[data-available="false"] {
    cursor: not-allowed;
    .inner {
      box-shadow: var(--box-shadow) inset;
    }
    .img,
    .itemName {
      filter: saturate(25%) brightness(25%);
    }
  }

  &[data-available="true"] {
    cursor: pointer;
  }

  &[data-high="true"],
  &[data-low="true"] {
    > .inner::before {
      content: "";
      position: absolute;
      top: 0;
      left: 0;
      width: 100%;
      height: 100%;
      box-shadow: 0 0 1rem 1px var(--glow-color, rgba(0, 0, 0, 0)) inset;
      border-radius: var(--card-border-radius, var(--border-radius));
      z-index: 1;
    }
  }

  &[data-winner="true"] {
    opacity: 1;
    box-shadow: 0 0 0 var(--outline-width) var(--form-element-focus-color);
    --border-color: var(--primary);
  }

  &[data-winner="false"] {
    > .inner {
      opacity: 0.66;
      filter: saturate(50%);
    }
  }

  &[data-ban="true"] {
    opacity: 0.66;

    > .inner {
      background: $ban-color;
    }

    > .inner > .img {
      opacity: 0.5;
    }
  }
}

.inner {
  object-fit: cover;
  position: relative;
  background-position: center;
  background-repeat: no-repeat;
  background-size: cover;
  background-clip: content-box;
  border-radius: var(--card-border-radius);
  margin: 0;
  overflow: hidden;
  box-shadow: 0 0 0 rgba(0, 0, 0, 0);
  width: 100%;
  height: 100%;
}

.img {
  // border: 1px solid var(--winner-border-color, rgba(0, 0, 0, 0));
  border-radius: var(--card-border-radius);
  box-shadow: 0 0 0 0 rgba(0, 0, 0, 0);
  object-fit: cover;
  background-size: cover;
  background-position: center;
  transition: 250ms opacity;
  width: 100%;
  height: 100%;
}

.itemName,
.signup {
  z-index: 1;
  text-shadow: 0 1px 0 black, 0 1px 2px black;
  font-weight: bold;
  position: absolute;
  left: calc(var(--spacing) * 0.33);
}

.itemName {
  bottom: calc(var(--spacing) * 0.33);
}

.signup {
  top: calc(var(--spacing) * 0.33);
  :global(.link) {
    color: white;
  }
}

$children-height: 40px;

.children {
  position: absolute;
  right: var(--spacing);
  bottom: calc(50% - #{$children-height * 0.5});
  height: $children-height;
  width: 48px;
  z-index: 2;
  > input {
    --border-color: var(--secondary);
    margin: 0 !important;
  }
}

////////////////////////////////////////////////////////////////////////////////
// Groups of cards
//

.group {
  display: grid;
  // display: flex;
  // flex-direction: row;
  max-height: 200px;
  transition: 250ms opacity, 250ms box-shadow;
  grid: "map high-pick" "map low-pick" / 1fr 1fr;
  box-shadow: var(--box-shadow);
  border-radius: var(--border-radius);

  &[data-has-score="true"] {
    grid: "map high-pick high-score" "map low-pick low-score" / 2fr 2fr 1fr;
    > .card:nth-child(2),
    > .card:nth-child(3) {
      --card-border-radius: 0 0 0 0;
      border-right: 0;
    }
    > input {
      width: 100% !important;
      height: 100% !important;
      margin: 0 !important;
      &:focus,
      &:active {
        z-index: 2;
      }
    }
    > input:nth-child(4) {
      border-radius: 0 var(--border-radius) 0 0;
      &:not(:where(:focus, :active)) {
        border-bottom: 0 solid var(--border-color);
      }
      grid-area: high-score;
    }
    > input:nth-child(5) {
      border-radius: 0 0 var(--border-radius) 0;
      grid-area: low-score;
    }
  }

  > .card:nth-child(1) {
    --card-border-radius: var(--border-radius) 0 0 var(--border-radius);
    grid-area: map;
    border-right: 0;
  }

  > .card:nth-child(2) {
    --card-border-radius: 0 var(--border-radius) 0 0;
    grid-area: high-pick;
    &:not([data-winner="true"]) {
      border-bottom: 0;
    }
  }

  > .card:nth-child(3) {
    --card-border-radius: 0 0 var(--border-radius) 0;
    grid-area: low-pick;
  }

  > .card {
    width: 100%;
    height: 100%;
    --box-shadow: 0 0 0 rgba(0, 0, 0, 0);
  }

  &[data-active="true"] {
    box-shadow: 0 0 0 var(--outline-width) var(--form-element-focus-color);
    .card {
      --border-color: var(--primary);
    }
  }

  &[data-active="false"] > .card {
    &::before {
      opacity: 0.33;
    }
    > .inner {
      opacity: 0.66;
    }
  }
}

////////////////////////////////////////////////////////////////////////////////
// Selector
//

.select {
  // margin: calc(-0.5 * var(--spacing)) calc(-1 * var(--spacing));

  border-radius: var(--border-radius);
  border: var(--border-width) solid var(--primary) !important;
  box-shadow: 0 0 0 var(--outline-width) var(--form-element-focus-color);

  > summary:active,
  > summary:focus,
  > summary:hover {
    box-shadow: 0 0 0 0 rgba(0, 0, 0, 0) !important;
  }

  > summary,
  > div[role="listbox"] {
    --border-width: 0;
  }

  summary::before,
  summary::after {
    display: none !important;
  }
}

.selectList {
  display: grid;
  grid-template-columns: repeat(auto-fill, minmax($card-min-width, 1fr));
  gap: var(--gap);
  padding: var(--gap);
  .card {
    width: 100%;
  }

  &[data-mode="pick"] > .card[data-available="true"] {
    &:focus,
    &:active,
    &[data-selected="true"] {
      box-shadow: 0 0 0 var(--outline-width) #{adjust-color($pick-color, $alpha: 0.5)};
    }
    &:focus,
    &:active,
    &:hover,
    &[data-selected="true"] {
      border: 1px solid $pick-color;
      background: $pick-color;
    }
    &:hover,
    &[data-selected="true"] {
      border: 1px solid $pick-color;
      .img {
        opacity: 50%;
      }
    }
  }

  &[data-mode="ban"] > .card[data-available="true"] {
    &:focus,
    &:active,
    &[data-selected="true"] {
      box-shadow: 0 0 0 var(--outline-width) #{adjust-color($ban-color, $alpha: 0.5)};
    }
    &:focus,
    &:active,
    &:hover,
    &[data-selected="true"] {
      border: 1px solid $ban-color;
      background: $ban-color;
    }
    &:hover,
    &[data-selected="true"] {
      border: 1px solid $ban-color;
      .img {
        opacity: 50%;
      }
    }
  }
}
